---
layout: handbook-page-toc
title: "Endpoint Detection and Response at GitLab"
description: "Endpoint Detection and Response: EDR, endpoint security, anti-virus, macOS, Windows, Linux, endpoint management"
---

## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}


# Endpoint Detection & Response Technology

## Overview
With an increased number of high profile breaches in the media today it is important we carefully consider the risk and external threats GitLab faces.  Due to our service and the companies that use us, it is credible that we are or will soon become a high profile target for adversaries looking to exploit GitLab or a GitLab customer. Endpoint detection and response (EDR) technology helps further strengthen endpoint security protecting not only GitLab, but each of our Team Members as well. All macOS, Windows and Linux devices used by GitLab Team Members for the purposes of fulfilling the responsibilities of their role as a GitLab Team Member are required have the SentinelOne EDR agent installed and functioning. The use of a Windows endpoint requires a specfic business reason and an approved exception as the [use of a Windows endpoint is prohibited](https://about.gitlab.com/handbook/business-technology/team-member-enablement/onboarding-access-requests/#laptop-configurations).

### What is Endpoint Detection and Response (EDR)?

EDR is a collection of endpoint security technologies that together record and store endpoint-system-level behaviors, use various data analytics techniques to detect suspicious system behavior, provide contextual information, block malicious activity, and provide remediation paths to restore affected systems.

### What is SentinelOne?
[SentinelOne](https://www.sentinelone.com/) is the EDR technology chosen by GitLab to help protect endpoint devices. All data associated with the effort conducted to evaluate EDR vendors while ultimately resulted in the chosing of SentinelOne can be found in the efforts [project repo](https://gitlab.com/gitlab-com/gl-security/security-research/edr-proof-of-concept/-/tree/master).

### Why is this necessary?

GitLab is a growing global company and as such we are required to meet compliance requirements in different countries, with one of those requirements being endpoint protection. An EDR solution meets that requirement. A number of customers also ask us if we are protecting their data by us protecting the systems that could potentially access their data, and ask specifically about EDR and Antivirus. EDR meets this requirement and addresses customer concerns.

Equally important is the security and privacy of our team members and their laptops. As GitLab continues to grow, we are increasing the likelihood that we will be targeted by malicious attackers. We want to ensure we have a way to protect team members and their laptops whether they are at home, on the road, or at the coffee shop down the street.

### How to get help with SentinelOne
If you need help with the SentinelOne agent on your endpoint please reach out to in the #sentinelone Slack channel. If you have security concerns please reach out to the Security team in the #security Slack channel.

### Exception request process
If SentinelOne is causing issues with your ability to fulfill the responsibilities of your role, you may request an exception to be granted using the [Information Security Policy Exception Management Process](https://about.gitlab.com/handbook/security/#information-security-policy-exception-management-process). Exceptions will be granted based on the goal of least needs, attempting to maximize effectiveness, efficiency, and security risk mitigation of SentinelOne while minimizing the negative impact on the team member. For this reason, rarely will an exception be granted to completely disable SentinelOne. Rather, an exception will be granted for specific directory paths, specific applications, or specific collections of data that SentinelOne may be negatively impacting through quarantine or system performance degradation. 

### What is the difference between EDR and Antivirus?

Antivirus can be seen as one part of the EDR complete security technology solution. Traditionally, antivirus software is a single program which serves basic purposes like scanning, detecting and removing viruses and different types of malware. For EDR, real time status, remediation paths, endpoint firewalls, and system behavioral analytics come together to create a comprehensive technology stack to protect against modern day digital attacks. 

### How does EDR technology work?

The first line of defense is stopping (or if configured, alerting) common threats on the laptop. As for additional or more "layered" lines of defense, certain types of activity (mainly involving processes on the laptop) are recorded and uploaded to a private instance for further processing and investigation. Much more sophisticated processing can take place for more thorough threat detection. As a result, the agent on the laptop is typically 40-60mb in size, as opposed to the older traditional antivirus solutions which can be well over a gigabyte. This results in less resources being used on the laptop including low CPU and low memory usage.

### Is this in addtion to Jamf or a replacement for Jamf?

The EDR technology is in addition to Jamf. While Jamf does offer security features and protections, an EDR solution combined with Jamf will offer great ability to detect and stop significant threats and advanced digital attacks on GitLab team member laptops.

Do not attempt to modify or remove SentinelOne components, unless instructed to do so by IT personnel for troubleshooting purposes.

### Will it monitor my local network?

No. The EDR solution only monitors the GitLab laptop, like an antivirus solution would (only much more efficiently).


### Why are we using a third party EDR system?

We do not want to write our own EDR solution, nor do we want to assemble a series of partial solutions into some type of chain to attempt to meet compliance requirements. Not only does a third party EDR solution allow us to meet requirements in a thorough and more economic way, it will show auditors, regulators, and customers that we are taking security seriously and implementing it consistently.

### Can we self-host our own solution to have more control?

We could, although this would require a substantial amount of effort to be able to have a self-managed solution that would address both compliance requirements and customer concerns. The chosen EDR technology is a single-tenant-hosted third party EDR solution to help ensure GitLab and Team Member data privacy.

### I dual boot two different operating systems, do they both need an agent?

Yes. Each operating system on a host computer that is used to access GitLab computing resources, infrastructure, or environments, will need have an EDR agent installed.

### I have several virtual hosts on my laptop, do they all need agents?

Yes. Each operating system on a computer, to include the host operating system, and all guest operation systems, that are used to access GitLab computing resources, infrastructure, or environments, will need have an EDR agent installed.


### I run my own antivirus solution on my work laptop, isn’t that enough?

While this effort is certainly appreciated, we need a way to be able to audit laptops to meet compliance requirements. We would still encourage you to run any such antivirus product up until the EDR solution has been rolled out to your laptop. After which time, we strongly encourage you to uninstall the antivirus solution previously installed. Multiple instances of these technologies, especially from different vendors, have the tendency to cause issues on an endpoint which may negatively impact system performance and your productivity.


### Who owns and manages the EDR solution at GitLab?

Jointly, the Security Department and IT will be responsible for different components. [SIRT](https://about.gitlab.com/handbook/security/security-operations/sirt/sec-incident-response.html) will manage the console for incidents, [IT Security](https://about.gitlab.com/handbook/business-technology/#security-and-compliance) will handle the configuration and deployment of agents (via Jamf), and [Compliance](https://about.gitlab.com/handbook/security/security-assurance/security-compliance/) will handle auditing components. With two departments responsible for usage, we deem it to be joint ownership. 

### What safeguards are in place to ensure that owners of this process can prevent abuse?

While such a possibility exists, we feel that the risk of something like this happening is much, much smaller than some of the risks that an endpoint management solution is made to address. Risks like:
 - Laptop is accidentally infected with malware and team-member is unaware of the infection.
 - Laptop is accidentally infected with malware or was the target of an attack.
 - The Laptop is compromised and the GitLab team members access and identity are used to further attack GitLab and our customers.
 - A new security exploit is discovered, and unpatched applications start getting exploited in the wild.
 - GitLab experiencing a targeted attack on our endpoints, which could lead to a compromise of the GitLab Production environment resulting in a customer data breach.

That being said, the EDR solution provides the ability to audit any processes and actions that have been conducted by an Administrator or the technology itself. The solution has role-based access controls implemented to limit access to certain features, and all of the use of such features is auditable.

### What options does a team member have to protect their home network privacy?

If you wish to add further privacy and security to your home network, you can further isolate your work machine by creating a separate network for it. While we cannot provide you with any direct support for this type of network setup, the Security team has a good writeup with some [examples](https://about.gitlab.com/handbook/security/network-isolation/) that might help to get you started.

### How do I install the SentinelOne agent on Linux?

{::options parse_block_html="true" /}

<div class="panel panel-info">
**Note**
{: .panel-heading}
<div class="panel-body">

If you are using Advanced Intrusion Detection Environment (AIDE) to monitor file integrity and detect intrusions, you will need to create an exclusion in AIDE. When both AIDE and the SentinelOne Agent are running together, AIDE is not able to update its database correctly. AIDE tries to scan a SentinelOne Directory and cannot scan it.

To create an exclusion for SentinelOne, edit `/etc/aide.conf` and add
`!/opt/sentinelone/mount` to the end to ignore the SentinelOne Agent mount directory:

```shell
echo '!/opt/sentinelone/mount' | sudo tee -a /etc/aide.conf
```

</div>
</div>

Prerequisites:

- Make sure you are using an approved [Linux distro](/handbook/it/operating-systems/).

1. [Download](https://drive.google.com/drive/search?q=type:folder%20sentinelone%20installers) the configuration file and the appropriate installer (DEB/RPM).
1. Get your laptop's serial number:

   ```shell
   sudo dmidecode -s system-serial-number
   ```

1. Edit `config.cfg` and update `S1_AGENT_CUSTOMER_ID`:

   1. Replace `tanuki` with your GitLab email username.
   1. Replace `ABCD123` with your laptop's serial number.
   1. Verify that the edited variable is formatted correctly with a hyphen separating the GitLab email and serial number. For example, `S1_AGENT_CUSTOMER_ID=jdoe@gitlab.com-ABCD1234`.

1. Install the package:

   - For RPM:

     ```shell
     sudo rpm -i --nodigest <sentinelone>.rpm S1_AGENT_INSTALL_CONFIG_PATH="/path/to/config.cfg"
     ```

   - For DEB:

     ```shell
     sudo dpkg -i --nodigest <sentinelone>.deb S1_AGENT_INSTALL_CONFIG_PATH="/path/to/config.cfg"
     ```

1. Wait five minutes, and then verify connectivity:

   ```shell
   sentinelctl management status
   ```

   You should see `Connectivity: On` and a valid SentinelOne URL.
   If this is not your result, reach out for assistance in the
   [`#sentinelone`](https://gitlab.slack.com/archives/C043PF9TU4X) channel.
   
### How do I calculate how much CPU is being used by SentinelOne on MacOS?

If you are using Activity Monitor to monitor CPU usage, be aware that it is calculated as the percent utilized for a single CPU thread. For example, an M1 Max laptop has 10 threads, so total CPU capacity is 1000%. To view the number of threads available on your system, open Terminal and run:

```shell
sysctl -n hw.cpu
```

Expect SentinelOne to use less than 10% of total CPU power (for example, marked as less than 100% on a M1 Max).


### How do I collect metrics for support on MacOS due to an issue with high CPU or RAM?

1. In a terminal, run:
`sudo sentinelctl metrics enable`
1. Reproduce the scenario that caused the issue, or run it for a few minutes. It will run in the background. You will not see output.
1. Collect the metric log:
`sudo sentinelctl metrics dump >> /tmp/metrics_dump.txt`
1. Turn off metric collection:
`sudo sentinelctl metrics disable`
1. Analyze the data as below, and then if needed share the file with #sentinelone and we will get a ticket open with SentinelOne support.
